Subject: Re: [OPSAWG] Question on draft-ietf-netmod-yang-model-classification

From: "Adrian Farrel" <[email-masked]>
Date: Wed, 25 Jan 2017 13:05:24 -0000

Hi Tianran,

I agree, it is very confusing.
It doesn't help (me) that folk are using the term "device model" when I can't
find a definition of that term. Maybe this is intended to be a synonym for
"Network Element YANG Modules" that is used in
draft-wu-opsawg-service-model-explained and
draft-ietf-netmod-yang-model-classification. In
draft-wu-opsawg-service-model-explained we tried to bring the terminology into
alignment by also using "Device Configuration Model" for this.

draft-ietf-netmod-yang-model-classification is pretty clear.

   Network Element YANG Modules describe the characteristics of a
   network device as defined by the vendor of that device.  The modules
   are commonly structured around features of the device, e.g. interface
   configuration [RFC7223], OSPF configuration [I-D.ietf-ospf-yang], and
   firewall rules definitions [I-D.ietf-netmod-acl-model].

   The module provides a coherent data model representation of the
   software environment consisting of the operating system and
   applications running on the device.  The decomposition, ordering, and
   execution of changes to the operating system and application
   configuration is the task of the agent that implements the module.

Note: "a network device".

So, if a module contains information about multiple devices (because coordinated
behavior is needed to enable a service) or about the network itself when
facilitating the service, then the module is something bigger than the Network
Element YANG Module as defined in draft-ietf-netmod-yang-model-classification.

That's OK. It doesn't make the module wrong or evil. It doesn't mean the module
has no value. It just means that the module needs a different name. 

In draft-wu-opsawg-service-model-explained we chose to call this type of module
a "Network Configuration Model".

I don't believe that these authors of draft-wu-opsawg-service-model-explained
can be clearer on our definitions and motivations for listing the particular
modules that are work-in-progress in particular categories. We could, however,
stop mentioning such modules if that make everyone less uncomfortable. This
would not substantially change the value of our document (which is about service
models).

Thanks,
Adrian

> -----Original Message-----
> From: Tianran Zhou [mailto:[email-masked]]
> Sent: 23 January 2017 09:33
> To: [email-masked]; [email-masked]
> Cc: [email-masked]; [email-masked]
> Subject: RE: [OPSAWG] Question on draft-ietf-netmod-yang-model-classification
> 
> To add more comments:
> 
> On the L2SM meeting, several people (4 or more) believed the 3 service
delivery
> model examples ([I-D.dhjain-bess-bgp-l3vpn-yang], [I-D.ietf-bess-l2vpn-yang]
> and [I-D.ietf-bess-evpn-yang]) are actually device models.
> 
> I think both of the two I-Ds ([draft-ietf-netmod-yang-model-classification]
and
> [draft-wu-opsawg-service-model-explained]) can check if those YANG models
> are device models or service models.
> 
> Regards,
> Tianran
> 
> > -----Original Message-----
> > From: OPSAWG [mailto:[email-masked]] On Behalf Of Adrian Farrel
> > Sent: Friday, January 20, 2017 12:25 AM
> > To: [email-masked]
> > Cc: [email-masked];
> > [email-masked]
> > Subject: [OPSAWG] Question on draft-ietf-netmod-yang-model-classification
> >
> > Hi,
> >
> > We've been trying to ensure that draft-wu-opsawg-service-model-explained
> > is consistent with the latest version of
> > draft-ietf-netmod-yang-model-classification. In discussions with Tianran
> > a question has come up.
> >
> > In section 2 you have a nice definition of Network Service YANG Modules
> > and this definition maps nicely to our definition of "service delivery
> > models".
> > Furthermore, your figure 1 shows Network Service YANG Modules on the
> > interface between OSS/BSS and the various network services.
> >
> > We have further defined "customer service models" at a higher layer still.
> > That is, on the interface to the customer. This (of course?) assumes that
> > the OSS/BSS is not customer code :-)
> >
> > However, your discussion of Network Service YANG Modules in section 2.1
> > seems slightly at odds, although this may be just ambiguity.
> >
> > For example, when you say, "Network Service YANG Modules describe the
> > characteristics of a service, as agreed upon with consumers of that
service,"
> > this is not the same as, "This model is used in the discussion between a
> > customer and a service provide to describe the characteristics of a
service."
> > That is, the former case could be arrived at after processing based on the
> > latter case - processing that we have called "service orchestration" but
> > might (of course) be what leads to the operator poking the OSS/BSS.
> >
> > This might all be fine and good, but later in the same section you say
"Network
> > Service YANG Modules define service models to be consumed by external
> > systems.
> > These modules are commonly designed, developed and deployed by network
> > infrastructure teams." And there you introduce two terms that are previously
> > undefined and only server to add ambiguity. Specifically "external to what?"
> > I could make and argument that the OSS is developed and deployed by
> network
> > infrastructure teams, ad also that the OSS is external to the network
itself.
> >
> > And, in between these two quoted pieces of text, you have...
> >
> >    As an example, the Network Service YANG Module defined in
> >    [YANG-Data-Model-for-L3VPN-service-delivery] provides an abstract
> >    model for Layer 3 IP VPN service configuration.
> >
> > Per my other email, this reference needs to be fixed. But I struggle to
> > see the L3SM module as consistent with your figure. It may or may not be
> > consistent with your text dependent on the interpretation.
> >
> > In draft-wu-opsawg-service-model-explained Figure 4 we have tried to show
> > how we (the authors) think L3SM fits into your classification. Here we place
> > L3SM further up the layering stack.
> >
> > [Apologies for not spotting this sooner. The citation
> > "YANG-Data-Model-for-L3VPN-service-delivery" includes the term "service
> > delivery" which I took to imply a different module.]
> >
> > Thanks,
> > Adrian
> >
> > _______________________________________________
> > OPSAWG mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/opsawg